/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: core_support.S 1067 2014-12-24 14:15:10Z ertl-honda $
 */

/*
 *        ¸⥸塼 ֥ARMѡ
 */

#define TOPPERS_MACRO_ONLY
#define TOPPERS_ASM_MACRO
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */

#include "kernel_impl.h"
#include "offset.h"
#include "target_asm.inc"

/*
 * 㳰٥
 */
    ASECTION(vector)
    AGLOBAL(vector_table)
ALABEL(vector_table)
    ldr pc, reset_vector       /* ꥻå             */
    ldr pc, undef_vector       /* ̤̿           */
    ldr pc, swi_vector         /* եȥ   */
    ldr pc, prefech_vector     /* ץեåܡ */
    ldr pc, data_abort_vector  /* ǡܡ       */
    ldr pc, reset_vector
    ldr pc, irq_vector         /* IRQ                  */
    ldr pc, fiq_vector         /* FIQ                  */


/*
 *  㳰٥̿ᤫ黲Ȥ
 *  襢ɥ쥹
 */
    AGLOBAL(vector_ref_tbl)
ALABEL(vector_ref_tbl)
ALABEL(reset_vector)
    ALONG   start
ALABEL(undef_vector)
    ALONG   undef_handler
ALABEL(swi_vector)
    ALONG   swi_handler
ALABEL(prefech_vector)
    ALONG   prefetch_handler
ALABEL(data_abort_vector)
    ALONG   data_abort_handler
ALABEL(irq_vector)
    ALONG   irq_handler
ALABEL(fiq_vector)
    ALONG   fiq_handler

#include "target_asm.inc"

/*
 *  ǥѥå
 *
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(dispatch)
ALABEL(dispatch)
    /*
     *  Υ롼ϡƥȡCPUå֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥
     */
    stmfd  sp!, {r4 - r11,lr}           /* 쥸¸ */
    my_pcb r0, r1                       /* p_runtskɤ߹ */
    ldr    r1, [r0,#PCB_p_runtsk]
    str    sp, [r1,#TCB_sp]             /* å¸ */
    adr    r2, dispatch_r
    str    r2, [r1,#TCB_pc]             /* ¹ԺƳϤ¸ */
    b      dispatcher

ALABEL(dispatch_r)
    ldmfd sp!,{r4 - r11,lr}     /* 쥸 */
    /*
     *  㳰롼εư
     *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
     */
    ldrb  r0,[r1,#TCB_enatex]
    tst   r0,#TCB_enatex_mask
    beq   dispatch_r_1          /* enatex  false ʤ꥿ */
    ldr   r0,[r1,#TCB_texptn]   /* texptn 0ʤ꥿       */
    tst   r0,r0
    beq   dispatch_r_1
    my_pcb r0, r1
    ldr    r1, [r0,#PCB_ipmflg] /* ipmflgfalseǤХ꥿ */
    tst    r1, r1
    bne   dispatch_call_texrtn  /* 㳰롼θƤӽФ */
ALABEL(dispatch_r_1)
    bx    lr

    /*
     *  Υޥ졼
     *  (r0)˥ޥ졼ΥץåäƤ뤿˲ʤ
     */
    ATEXT
    AALIGN(2)
    AGLOBAL(dispatch_and_migrate)
ALABEL(dispatch_and_migrate)
    stmfd  sp!, {r4 - r11,lr}           /* 쥸¸ */
    my_pcb r2, r1                       /* p_runtskɤ߹ */
    ldr    r1, [r2,#PCB_p_runtsk]
    str    sp, [r1,#TCB_sp]             /* å¸ */
    adr    r3, dispatch_r
    str    r3, [r1,#TCB_pc]             /* ¹ԺƳϤ¸ */
    ldr    sp, [r2,#PCB_istkpt]
    b      migrate_self                 /* Υޥ졼롼 */

    /*
     *  ߤΥƥȤΤƥޥ졼
     *  (r0)˥ޥ졼ΥץåäƤ뤿˲ʤ
     */
    ATEXT
    AALIGN(2)
    AGLOBAL(exit_and_migrate)
ALABEL(exit_and_migrate)
    my_pcb r2, r1
    ldr    sp, [r2,#PCB_istkpt]         /* 󥿥ƥѥåڤؤ */
    b      exit_and_migrate_self        /* exitȥޥ졼롼 */

/*
 *  ǥѥåưϡcpu_support.S
 */
    AGLOBAL(start_dispatch)
ALABEL(start_dispatch)
    /*
     *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
     *  ʳߥå֤ƱˤǸƤӽФ롥ޤ󥿥ƥ
     *  ȤƤӽФ뤳ȤꤷƤ롥
     *
     *  dispatcherϡCPUå֡ʥǥΡ˳ͥ٥ޥ
     *  ֡㳰ʳ/CPU㳰ˤΥͥȲ0ǸƤӽФ
     *  target_initializeǤϡʥǥΡ˳ͥ٥ޥ
     *  ȤͥγߤǤFIQĤ뤳Ȥǡ
     *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
     *  ޤinitialize_taskdisdspFALSE˽Ƥ뤿ᡤǥ
     *  ѥåľ֤ˤʤäƤ롥
     *
     */
#ifndef USE_GIC_CPULOCK
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) /* CPUå֤ */
#else /* USE_GIC_CPULOCK */
    /*
     *  prc_initializeǡlock_flagTRUEˡsaved_iipmIIPM_ENAALL
     *  Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
     *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
     */
    gic_lock r0, r1
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET) 
#endif /* USE_GIC_CPULOCK */
    my_pcb r0, r1                          /* 㳰ʳ/CPU㳰ˤΥͥȲ */
    mov   r1, #0                           /* 0                              */
    str   r1, [r0, #PCB_excpt_nest_count]
    b     dispatcher_0

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    AGLOBAL(exit_and_dispatch)
ALABEL(exit_and_dispatch)
    /* ǥѥåΡdispatcherˤ */
    my_pcb r0, r1                       /* my_pcbɤ߹ */

/*
 *  ǥѥå
 */
ALABEL(dispatcher)
    /*
     *  Υ롼ϡƥȡCPUå֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
     *
     *  ʤѡХ⡼ɡIRQػߤȤʤäƤ롥
     *  r0ˤϡmy_pcb ؤΥݥ󥿤
     */
#ifdef LOG_DSP_ENTER
    stmfd sp!, {r0}
    ldr   r1, [r0, #PCB_p_runtsk]
    mov   r0, r1
    bl    log_dsp_enter
    ldmfd sp!, {r0}
#endif /* LOG_DSP_ENTER */
ALABEL(dispatcher_0)
    ldr   r1, [r0, #PCB_p_schedtsk] /* p_schedtskp_runtsk */
    str   r1, [r0, #PCB_p_runtsk]
    cmp   r1, #0            /* p_runtskNULLʤdispatcher_1 */
    beq   dispatcher_1
    ldr   sp, [r1,#TCB_sp]  /* å */
#ifdef LOG_DSP_LEAVE
    mov   r0, r1            /* p_runtskѥ᡼ */
    mov   r4, r1            /* r1ϥå쥸ʤΤ¸ */
    bl    log_dsp_leave
    mov   r1, r4
#endif /* LOG_DSP_LEAVE */
    ldr   pc, [r1,#TCB_pc]  /* ¹ԺƳϤ */

ALABEL(dispatcher_1)
    /*
     * CPUå֤βȡ󥿥ƥȼ¹Ծ֤ؤ
     * 򤹤
     */
    ldr   sp, [r0,#PCB_istkpt]         /* 󥿥ƥȤΥå */
    add   r6, r0, #PCB_reqflg          /* r6 <- reqflg */
    add   r7, r0, #PCB_excpt_nest_count
    mov   r4, #0
    mov   r5, #1
ALABEL(dispatcher_2)
    /*
     *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
     *
     *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
     *  ߽ˤɤΥåȤȤβȡ
     *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣롥
     *
     *  ץåԤ˰ܹԤȡߵĤȤϡԲ
     *  ʬ˹Ԥʤɬפ롥
     *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
     *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
     *  ˤ⤫餺ץåԤˤʤäƤޤ
     *
     *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
     *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
     *  ݤưͤ˹פʤʤ롥
     *
     *  åȤˤäƤϡϥ⡼˰ܹԤ뤿ᡤɸˡ
     *  ۤʤ礬ɬפʾ礬롥
     *  Τ褦ʥåȤǤϡåȰ¸ˤơTOPPERS_CUSTOM_IDLE
     *  ֥ޥȤơtoppers_asm_custom_idle Ѱ
     *  Ф褤
     *
     *  ʤtoppers_asm_custom_idle εҤˤäƤϡΥ쥸
     *  toppers_asm_custom_idleǻѤ뤿ᡤ
     *  toppers_asm_custom_idle ǻѤϡ¸뤳ȡ
     *  Υ쥸 Calee saved 쥸Ǥ뤿ᡤ
     *  toppers_asm_custom_idle ȤƴؿƤӽФ򤷤ϡƤӽФ
     *  ؿǼưŪ¸뤿ᡤ֥٥Ǥ¸ɬ
     *  פʤ
     *
     *  쥸 : 
     *   r4      : '0'
     *   r5      : '1'
     *   r6      : reqflgΥɥ쥹
     *   r7      : excpt_nest_countΥɥ쥹
     *   sp      : 󥿥ƥѤΥåƬɥ쥹
     */
    str   r5, [r7]                          /* excpt_nest_count = 1 */

#ifdef TOPPERS_CUSTOM_IDLE
    toppers_asm_custom_idle
#else
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET) /* ߵ(ƥ⡼) */
    nop
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) /* CPUå(ƥ⡼) */
#endif /* TOPPERS_CUSTOM_IDLE */
    ldr   r8, [r6]        /* reqflgfalseʤdispatcher_2 */
    cmp   r8, #0
    beq   dispatcher_2
    str   r4, [r6]        /* reqflgFALSE */
    str   r4, [r7]        /* excpt_nest_count = 0 */
    my_pcb r0, r1         /* my_pcbɤ߹ */
    b     dispatcher_0


/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
    AGLOBAL(call_exit_kernel)
ALABEL(call_exit_kernel)
    msr  cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET AOR CPSR_IRQ_BIT AOR CPSR_FIQ_BIT)
    my_pcb r2, r1
    ldr    sp, [r2,#PCB_istkpt]         /* 󥿥ƥѥåڤؤ */
    b     exit_kernel

/*
 *  ϻ
 *
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
 */
    ATEXT
    AGLOBAL(start_r)
ALABEL(start_r)
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET) /* CPUå֤ */
#ifdef USE_GIC_CPULOCK
    gic_unlock_cpu r0, r2
#endif /* USE_GIC_CPULOCK */
    ldr   lr, =ext_tsk                      /*  */
    ldr   r2, [r1, #TCB_p_tinib]            /* p_runtsk->p_tinibr2  */
    ldr   r0, [r2, #TINIB_exinf]            /* exinf쥸r0  */
    ldr   r1, [r2, #TINIB_task]             /* ưϤ˥ */
    bx    r1

/*
 *  ǥѥå׵ѤΥץåֳߤΥХѥ
 *
 *  ѰդƤ ipi_handler ƤӽФ˥ǥѥå
 *  ƤӽФǤ⳰¦Υ롼Ǥʤϡreqflg򥻥åȤ롥
 *  PCBΥɥ쥹r0äƤ뤳ȤꤷƤ롥
 */
#ifdef USE_IPI_DIS_HANDER_BYPASS
    AGLOBAL(ret_int_ipi_dispatch)
ALABEL(ret_int_ipi_dispatch)
#ifdef USE_GIC_CPULOCK
    gic_lock_cpu r1,r2
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET)
#endif /* USE_GIC_CPULOCK */
    ldr   r2, [r0,#PCB_excpt_nest_count] /* 褬ƥȤʤ */
    cmp   r2, #0                         /* ret_int_4 */
    beq   ret_int_4
    mov   r1, #1                         /* 褬󥿥ƥȤʤ */
    str   r1, [r0, #PCB_reqflg]          /* reqflgtrueˤƥ꥿       */
    b     ret_int_2
#endif /* USE_IPI_DIS_HANDER_BYPASS */

/*
 *  CPU㳰ϥɥи
 *
 *  ret_excϡCPU㳰ϥɥ餫äľ˼¹Ԥ롼ǡ
 *  CPU㳰ϥɥ齪λ塤åȰ¸ν¹Ԥ塤
 *  ͥγߤػߡåCPU㳰Υåˡ
 *  r0CPU㳰ȯ˼Ƥ륹ԥåͤ줿
 *  ǸƤӽФ롥
 */
    ATEXT
    AGLOBAL(ret_exc)
ALABEL(ret_exc)
    /*
     * CPU㳰ȯ˥ԥåƤСԥå
     * βϹԤʤ
     */
    cmp  r0, #0
    bne  ret_int_1

/*
 *  ߥϥɥ/CPU㳰ϥɥи
 *
 *  ret_intϡߥϥɥ餫äľ˼¹Ԥ롼ǡ
 *  ߥϥɥ齪λ塤åȰ¸ν¹Ԥ塤
 *  ͥγߤػߡåΥåˤ
 *  ֤ǸƤӽФ롥
 */
    AGLOBAL(ret_int)
ALABEL(ret_int)
    /*
     *  ԥåƤв
     */
    my_pcb r0, r1  /*  */
    bl    force_unlock_spin

ALABEL(ret_int_1)
    /*
     *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
     */
    my_pcb r0, r1
    ldr   r1, [r0,#PCB_excpt_nest_count] /* r1 <-excpt_nest_count */
    sub   r2, r1, #1
    str   r2, [r0,#PCB_excpt_nest_count]
    cmp   r2, #0                  /* 褬󥿥ƥȤʤ */
    bne   ret_int_2               /* ˥꥿                   */

    /*
     *  reqflgå˳ߤػߤΤϡreqflgå
     *  ľ˳ߥϥɥ餬ư졤ǥǥѥå׵
     *  줿ˡ˥ǥѥåʤȤ꤬뤿
     *  Ǥ롥
     */
    ldr   r1, [r0, #PCB_reqflg] /* reqflgtrueǤret_int_3 */
    cmp   r1, #0
    bne   ret_int_3

    AGLOBAL(ret_int_2)
ALABEL(ret_int_2)
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤʤ
     *  ʤʤ
     *  ARMǤϡCPSRIRQӥåȤCPUå֤Ȥ뤿ᡤñ˥꥿
     *  Ф褤
     */
#ifdef USE_GIC_CPULOCK
    /* 
     * ߤͥȤȥåŪˤENABLE_NMFI Ȱ˻ȤͥȤ1ʤȯʤʤ 
     */
    gic_unlock_cpu r0, r2
#endif /* USE_GIC_CPULOCK */
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    ldmfd sp!,{r1}              /* CPSR */
    msr   spsr_cxsf, r1              /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ƥȤ^դʤΤǡcpsr <- spsr */
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    ldmfd sp!,{r0-r3,ip,lr}
    rfeia sp!
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

ALABEL(ret_int_3)
    /*
     *  Ǥϡ褬Ǥꡤåϡåξ
     *  ˥å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
     *  ץåϡѡХ⡼ɡͥγߤػ
     *  ֤ȤʤäƤ롥
     */
    mov   r1, #0                   /* reqflgFALSE */
    str   r1, [r0, #PCB_reqflg]

    /*
     *  CPUå֤˰ܹԤͥ٥ޥ߽ͤ
     *  ꤹ롥
     *
     *  λCPUå֤ȤΤϡdispatcherʬȡ
     *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
     *  Ǥ롥
     *
     *  CPUå֤˴ؤƤϡARMǤϡCPSRIRQӥåȤCPUå
     *  ֤ɽ뤿ᡤǤϡä˲Ԥʤ
     *
     *  ͥ٥ޥ˴ؤƤϡåۤʤ뤿ᡤ
     *  ߥϥɥ齪λľ˥åȰ¸ǳ߽ͤ
     *  ꤹ롥
     */

#ifdef USE_GIC_CPULOCK
    gic_lock_cpu r1,r2
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET)
#endif /* USE_GIC_CPULOCK */

ALABEL(ret_int_4)
    /*
     *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
     *  ǥѥåԤʤΥåɬפʤΤϡ㳰
     *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
     *  reqflgTRUEˤ뤿Ǥ롥
     */
    ldr   r1, [r0, #PCB_p_runtsk] /* p_runtsk r1ɤ߹ */
    ldr   r2, [r0, #PCB_dspflg]   /* dspflgfalseʤret_int_r_1 */
    cmp   r2, #0
    beq   ret_int_r_1

    /*
     *  ǥѥåɬå
     */
    ldr   r2, [r0, #PCB_p_schedtsk] /* p_schedtsk r2ɤ߹ */
    cmp   r1, r2              /* p_runtskp_schedtskƱʤ */
    beq   ret_int_r_1         /*                    ret_int_r_1 */
    stmfd sp!, {r4-r11}       /* ĤΥ쥸¸ */
    str   sp, [r1,#TCB_sp]    /* å¸ */
    adr   r2, ret_int_r       /* ¹ԺƳϤ¸   */
    str   r2, [r1,#TCB_pc]
    b     dispatcher

ALABEL(ret_int_r)
    ldmfd sp!, {r4-r11}       /* 쥸 */
ALABEL(ret_int_r_1)
    /*
     *  enatextrueǡtexptn0ǤʤipmflgtrueǤС
     *  㳰롼ƤӽФ
     *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
     */
    ldrb  r0, [r1,#TCB_enatex]
    tst   r0, #TCB_enatex_mask
    beq   ret_int_r_2            /* enatex  false ʤ ret_int_r2  */
    ldr   r0, [r1,#TCB_texptn]   /* texptn               */
    tst   r0, r0                 /* texptn 0ʤ꥿       */
    beq   ret_int_r_2
    my_pcb r0, r1
    ldr    r1, [r0,#PCB_ipmflg] /* ipmflgfalseǤХ꥿ */
    tst    r1, r1
    blne  dispatch_call_texrtn   /* 㳰롼θƤӽФ */
ALABEL(ret_int_r_2)
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ
     *  ˤ롥ARMCPSRIRQӥåȤˤäCPUå֤ɽƤ
     *  뤿ᡤΤޤޥ꥿󤹤Ф褤
     */

#ifdef USE_GIC_CPULOCK
    /* 
     * ߤͥȤȥåŪˤENABLE_NMFI Ȱ˻ȤͥȤ1ʤȯʤʤ 
     */
    gic_unlock_cpu r0, r2
#endif /* USE_GIC_CPULOCK */

#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    ldmfd sp!, {r0}             /* spsr  */
    msr   spsr_cxsf,r0          /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /*  ^դʤΤǡcpsr <- spsr */
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    ldmfd sp!,{r0-r3,ip,lr}
    rfeia sp!
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

/*
 * CPU㳰ϥɥ
 *
 * CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롥
 *
 */

/*
 *  ̤̿ 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(undef_handler)
ALABEL(undef_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /*
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿̤⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_UND AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /*
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC!

    /*
     *  㳰ȯư⡼(ѡХ⡼)
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr}
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_UNDEF
    b     target_exc_handler

/*
 *  SWI 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(swi_handler)
ALABEL(swi_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /*
     *  㳰ȯư⡼(ѡХ⡼)
     *  ѡХ⡼ɤCPUå֤Ȥ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */
    mov   r0, lr
    mrs   r1, spsr
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /*
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC!

    /*
     *  㳰ȯư⡼(ѡХ⡼)
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr}
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_SWI
    b     target_exc_handler

/*
 *  ץեåܡ 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(prefetch_handler)
ALABEL(prefetch_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /*
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿˥ܡȥ⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_ABT AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /*
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC!

    /*
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr}
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_PABORT
    b     target_exc_handler

/*
 *  ǡܡ 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(data_abort_handler)
ALABEL(data_abort_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /*
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿˥ܡȥ⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_ABT AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /*
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC!

    /*
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr}
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_DABORT
    b     target_exc_handler


#ifndef TARGET_FIQ_HANDLER
/*
 *  FIQ 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(fiq_handler)
ALABEL(fiq_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /*
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_FIQ_BIT AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿FIQ⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_FIQ AOR CPSR_FIQ_BIT AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /*
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC!

    /*
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr}
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_FIQ
    b     target_exc_handler
#endif /* TARGET_FIQ_HANDLER */

/*
 *  Ԥ
 */
#ifndef TOPPERS_CUSTOM_SILDLYNSE
    AGLOBAL(_sil_dly_nse)
ALABEL(_sil_dly_nse)
    sub   r0, r0, #SIL_DLY_TIM1
    cmp   r0, #0
    bgt   _sil_dly_nse1
    bxle  lr
ALABEL(_sil_dly_nse1)
    sub   r0, r0, #SIL_DLY_TIM2
    cmp   r0, #0
    bgt   _sil_dly_nse1
    bxle  lr
#endif /* TOPPERS_CUSTOM_SILDLYNSE */

#ifdef __thumb__
    ATEXT
    AALIGN(2)
    AGLOBAL(current_sr)
ALABEL(current_sr)
    mrs   r0, cpsr
    bx    lr

   AGLOBAL(set_sr)
ALABEL(set_sr)
    msr   cpsr_cxsf, r0
    bx    lr
#endif /* __thumb__ */
