/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: chip_ipi.h 955 2012-10-30 07:31:22Z ertl-honda $
 */

/*
 *  ץåֳߥɥ饤СMPCOREѡ
 */

#ifndef TOPPERS_CHIP_IPI_H
#define TOPPERS_CHIP_IPI_H

#include "mpcore.h"

/*
 *  ǥѥå׵ѥץåֳߤγֹ
 */
#define INTNO_IPI_DIS_PRC1   (0x00010000 | IPINO_DIS)
#define INTNO_IPI_DIS_PRC2   (0x00020000 | IPINO_DIS)
#define INTNO_IPI_DIS_PRC3   (0x00030000 | IPINO_DIS)
#define INTNO_IPI_DIS_PRC4   (0x00040000 | IPINO_DIS)

/*
 *  ͥ뽪λѤΥץåֳߤγֹ
 */
#define INTNO_IPI_EXT_PRC1   (0x00010000 | IPINO_EXT)
#define INTNO_IPI_EXT_PRC2   (0x00020000 | IPINO_EXT)
#define INTNO_IPI_EXT_PRC3   (0x00030000 | IPINO_EXT)
#define INTNO_IPI_EXT_PRC4   (0x00040000 | IPINO_EXT)

/*
 *  ǥѥå׵ѤΥץåֳߤγߥϥɥֹ
 */
#define INHNO_IPI_DIS_PRC1   (0x00010000 | IPINO_DIS)
#define INHNO_IPI_DIS_PRC2   (0x00020000 | IPINO_DIS)
#define INHNO_IPI_DIS_PRC3   (0x00030000 | IPINO_DIS)
#define INHNO_IPI_DIS_PRC4   (0x00040000 | IPINO_DIS)

/*
 *  ͥ뽪λѤΥץåֳߤγߥϥɥֹ
 */
#define INHNO_IPI_EXT_PRC1   (0x00010000 | IPINO_EXT)
#define INHNO_IPI_EXT_PRC2   (0x00020000 | IPINO_EXT)
#define INHNO_IPI_EXT_PRC3   (0x00030000 | IPINO_EXT)
#define INHNO_IPI_EXT_PRC4   (0x00040000 | IPINO_EXT)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǥѥåѥץåֳߤȯ
 */
Inline void
target_ipi_raise(uint_t prcid)
{
	dic_swi((1<<(prcid-1)), IPINO_DIS);
}

/*
 *  ǥѥåѥץåֳߤΥꥢ
 */
Inline void
target_ipi_clear(void)
{

}

#ifdef USE_IPI_DIS_HANDER_BYPASS
/*
 *  ͥ뽪λѤΥץåֳߥϥɥ
 */
extern void _kernel_ipi_ext_handler(void);
#endif /* USE_IPI_DIS_HANDER_BYPASS */

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CHIP_IPI_H */
